#include <stdlib.h>
#include<stdio.h>
#include <sys/timeb.h>
#include <time.h>
////#include <windows.h>
#include <math.h>

////#include "f2c.h"


#include <sys/time.h>
#include <sys/resource.h>
#include <sys/types.h>
#include <sys/timeb.h>

double taucs_wtime()
{
  struct timeb T;
  /*static int first_time    = 1;*/
  /*  static time_t start_time, time_diff;
      static time_t start_mill, mill_diff;
  */

  static time_t time_diff;
  static time_t mill_diff;
  /*int    rc;*/
  double dt;

  (void) ftime( &T );
  /*
  if (first_time) {
    first_time = 0;
    start_time = T.time;
    start_mill = T.millitm;
  }

  time_diff = T.time - start_time;
  mill_diff = T.millitm - start_mill;
  */
  time_diff = T.time;
  mill_diff = T.millitm;

  dt = ((double) time_diff) + (1e-3) * ((double) mill_diff);

  return dt;
}


#define MAXINT 32768

extern double mx;
extern double first_mx;
extern double growth_factor;
extern int max_band;

void prn_bnd_mtrx(int n, double *A, int lda);
int snapback (char *uplo, /*int*/ long *n, /*int*/long *kd, double *ab, /*int*/long *ldab,  int *bandwidth_u, int *bandwidth_l, int *step_type, double *workspace,/*int*/long *info);
int growth_snapback (char *uplo, /*int*/ long *n, /*int*/long *kd, double *ab, /*int*/long *ldab,  int *bandwidth_u, int *bandwidth_l, int *step_type, double *workspace,/*int*/long *info);
/* Subroutine */ int dgbtrf_(long *m, long *n, long *kl, long *ku,
	 double *ab, long *ldab, long *ipiv, long *info);
/* Subroutine */ /*int dgbtrf_(integer *m, integer *n, integer *kl, integer *ku,
	 doublereal *ab, integer *ldab, integer *ipiv, integer *info);*/
/* Subroutine */ int dgbtf2_(long *m, long *n, long *kl, long *ku,
	 double *ab, long *ldab, long *ipiv, long *info);
/* Subroutine */ /*int dgbtf2_(integer *m, integer *n, integer *kl, integer *ku,
	 doublereal *ab, integer *ldab, integer *ipiv, integer *info);*/
//////void ld_mat(char *file_name, double *A, int m, int n);
void ld_mat_ijv(char *file_name, double *A, int m, int n, int load_only_upper);
void st_mat(char *file_name, double *A, int m, int n);
int snapback_solve(char *transa, /*int*/long *n, /*int*/ long *kd, int *nhrs, double *a, /*int*/long *lda, int *bandwidth_u, int *bandwidth_l, int *step_type, double *b, /*int*/long *info);

int main(int argv, char*argc[]){

   /*int*/long n;
   /*int*/long band;
   int band_factor=3;
   /*int*/long lda;
   /*int*/long info;
   char uplo[]="u";
   int *bandwidth_u, *bandwidth_l, *step_type;

   double dt1,dt2;
////   LARGE_INTEGER lpPerformanceCountBeg, lpPerformanceCountEnd, lpPerformanceFreq;

   long *ipiv;

   double *A,*b,*bt,*x,*b_st,*x_st;
   double norm=0.0,x_norm=0.0, b_norm=0.0;

   double *workspace;
   int i;

   int j,ftr=0,str=0,ttr=0;

   if(argv!=2){
      printf("usage: %s <input mat>\n",argc[0]);
      return 1;
   }

   {
      FILE *f;
      f=fopen(argc[1],"r");
      if(!f){
         printf("Couldn't open file %d:%s\n",__LINE__,__FILE__);
		 exit(1);
      }
  	  fscanf(f,"%ld%ld",&n,&band);
      fclose(f);
   }
   
/*   n=atoi(argc[5]);
   band=atoi(argc[6]);
*/
   lda=band*band_factor*2+1;

   A=(double *)malloc(sizeof(double)*(n)*lda);
   if(!A){
	   printf("Allocation error (%ld)\n",sizeof(double)*(n)*lda);
       exit(1);
   }
   workspace=(double *)malloc(sizeof(double)*lda);

   bandwidth_u=(int*)calloc(n,sizeof(int));
   bandwidth_l=(int*)calloc(n,sizeof(int));
   step_type=(int*)calloc(n,sizeof(int));

   ld_mat_ijv(argc[1], A, lda, n, 1);
   x=(double *)malloc(sizeof(double)*n);
   x_st=(double *)malloc(sizeof(double)*n);
   b=(double *)malloc(sizeof(double)*n);
   b_st=(double *)malloc(sizeof(double)*n);
   bt=(double *)malloc(sizeof(double)*n);

   for(i=0;i<n;i++) {
      x[i]=(rand()/(double)RAND_MAX); 
      b[i]=0; x_st[i]=x[i]; 
      x_norm+=x[i]*x[i];}
   x_norm=sqrt(x_norm);
   {
      double alpha=1;
      int ione=1;
      double dzero=0;

      dsbmv_("U",&n,&band,&alpha,A+band*band_factor-band,&lda,x,&ione,&dzero,b,&ione);
   }
   for(i=0;i<n;i++) {bt[i]=b[i]; b_st[i]=b[i]; b_norm+=b[i]*b[i];}
   b_norm=sqrt(b_norm);

////   QueryPerformanceFrequency(&lpPerformanceFreq);
////   QueryPerformanceCounter(&lpPerformanceCountBeg);

   dt1=taucs_wtime();
   snapback (uplo, &n, &band, A, &lda, bandwidth_u, bandwidth_l, step_type, workspace, &info);
   dt2=taucs_wtime();
////   QueryPerformanceCounter(&lpPerformanceCountEnd);

////   printf("time: %g ",((float)lpPerformanceCountEnd.QuadPart-(float)lpPerformanceCountBeg.QuadPart)/(float)lpPerformanceFreq.QuadPart*1000);
   printf("time: %g ",(dt2-dt1));
   fflush(stdout);

   snapback_solve(NULL, &n, &band, NULL, A, &lda, bandwidth_u, bandwidth_l, step_type, b, &info);

   norm=0;
   for(i=0;i<n;i++){
      norm+=(x[i]-b[i])*(x[i]-b[i]);
   }
   norm=sqrt(norm)/x_norm;
   printf("fwd error: %g ",norm);
   fflush(stdout);
//   st_mat("debug4.mtx", A, lda, n);
//printf("Finished saving factors\n");
//fflush(stdout);
//////   ld_mat(argc[1], A, lda, n);
   ld_mat_ijv(argc[1], A, lda, n, 1);
   {
      double alpha=1;
      int ione=1;
      double dzero=0;
      dsbmv_("U",&n,&band,&alpha,A+band*band_factor-band,&lda,b,&ione,&dzero,x,&ione);
   }

   norm=0;
   for(i=0;i<n;i++){
      norm+=(x[i]-bt[i])*(x[i]-bt[i]);
   }
   norm=sqrt(norm)/b_norm;
   printf("residual: %g ",norm);
   fflush(stdout);


///////ld_mat(argc[1], A, lda, n);
   ld_mat_ijv(argc[1], A, lda, n, 1);

   free(bandwidth_u);
   free(bandwidth_l);
   free(step_type);
   bandwidth_u=(int*)calloc(n,sizeof(int));
   bandwidth_l=(int*)calloc(n,sizeof(int));
   step_type=(int*)calloc(n,sizeof(int));
   growth_snapback (uplo, &n, &band, A, &lda, bandwidth_u, bandwidth_l, step_type, workspace, &info);
   printf("growth: %g ",growth_factor);
   printf("max_band_reduced_matrix: %d ",max_band);
   printf("growth_factors: %g ",mx/first_mx);
   fflush(stdout);

   max_band=0;
   calc_max_band(bandwidth_u, bandwidth_l, n);
   printf("max_band_factors: %d ",max_band);
   fflush(stdout);  

   for(j=0; j<n; j++)
      if(step_type[j]==0)
         ftr++;
      else if(step_type[j]==1)
         str++;
      else if(step_type[j]==2)
         ttr++;

   printf("first_type: %d second_type: %d third_type: %d ",ftr,str,ttr);
   fflush(stdout);

//////   st_mat(argc[2], A, lda, n);

   free(workspace);

   
   /*int*/ipiv=(long *)malloc(sizeof(long)*n);   

//////   ld_mat(argc[3], A, lda, n);
   ld_mat_ijv(argc[1], A, lda, n, 0);
////   QueryPerformanceFrequency(&lpPerformanceFreq);
////   QueryPerformanceCounter(&lpPerformanceCountBeg);
   dt1=taucs_wtime();
   dgbtrf_(&n, &n, &band, &band, &(A[band*band_factor-2*band]), &lda, ipiv, &info);
   dt2=taucs_wtime();
////   QueryPerformanceCounter(&lpPerformanceCountEnd);
////   printf("dgbtrf_time: %g ",((float)lpPerformanceCountEnd.QuadPart-(float)lpPerformanceCountBeg.QuadPart)/(float)lpPerformanceFreq.QuadPart*1000);
   printf("dgbtrf_time: %g ",(dt2-dt1));
   fflush(stdout);
//////   ld_mat(argc[1], A, lda, n);
   ld_mat_ijv(argc[1], A, lda, n, 1);
   for(i=0;i<n;i++) {x[i]=x_st[i]; b[i]=b_st[i];}
/*   for(i=0;i<n;i++) {x[i]=rand()/(double)RAND_MAX; b[i]=0;}
   {
      double alpha=1;
      int ione=1;
      double dzero=0;
      dsbmv_("U",&n,&band,&alpha,A+band*band_factor-band,&lda,x,&ione,&dzero,b,&ione);
   }*/
   for(i=0;i<n;i++) bt[i]=b[i];
//////   ld_mat(argc[3], A, lda, n);
   ld_mat_ijv(argc[1], A, lda, n, 0);
////  QueryPerformanceFrequency(&lpPerformanceFreq);
////   QueryPerformanceCounter(&lpPerformanceCountBeg);
   dt1=taucs_wtime();
   dgbtf2_(&n, &n, &band, &band, &(A[band*band_factor-2*band]), &lda, ipiv, &info);
   dt2=taucs_wtime();
////   QueryPerformanceCounter(&lpPerformanceCountEnd);
////   printf("dgbtf2_time: %g ",((float)lpPerformanceCountEnd.QuadPart-(float)lpPerformanceCountBeg.QuadPart)/(float)lpPerformanceFreq.QuadPart*1000);
   printf("dgbtf2_time: %g ",(dt2-dt1));
   fflush(stdout);
   {
      int ione=1;
      dgbtrs_("N", &n, &band, &band, &ione, &(A[band*band_factor-2*band]), &lda, ipiv, b, &n, &info);
   }

   norm=0;
   for(i=0;i<n;i++)
      norm+=(x_st[i]-b[i])*(x_st[i]-b[i]);
   norm=sqrt(norm)/x_norm;
   printf("gepp_fwd_err: %g ",norm);
   fflush(stdout);

//////   ld_mat(argc[1], A, lda, n);
   ld_mat_ijv(argc[1], A, lda, n, 1);
   {
      double alpha=1;
      int ione=1;
      double dzero=0;
      dsbmv_("U",&n,&band,&alpha,A+band*band_factor-band,&lda,b,&ione,&dzero,x,&ione);
   }
   norm=0;
   for(i=0;i<n;i++)
      norm+=(x[i]-bt[i])*(x[i]-bt[i]);
   norm=sqrt(norm)/b_norm;
   printf("gepp_residual: %g\n",norm);
   fflush(stdout);
//////   st_mat(argc[4], A, lda, n);

   free(ipiv);

   free(bandwidth_u);
   free(bandwidth_l);
   free(step_type);


   free(b_st);
   free(b);
   free(bt);
   free(x_st);
   free(x);
   free(A);

   return 0;
}
