#include <math.h>
#include <stdlib.h>

#define BAND_FACTOR 3
#define a_ref(a_1,a_2) a[(a_2)*a_dim1 + a_1]
#define min_(h,b) ((h) <= (b) ? (h) : (b))
#define abs(x) ((x) >= 0 ? (x) : -(x))

int snapback_solve(char *transa, /*int*/long *n, /*int*/ long *kd, int *nhrs, double *a, /*int*/long *lda, int *bandwidth_u, int *bandwidth_l, int *step_type, double *b, /*int*/long *info){

   int i,j;
   int a_dim1,a_offset;
   int n1,kd1;
   int ldv1,ldv2;
   int bw;
   double tmp;
   double givens, sin_alpha, cos_alpha;

   a_dim1 = *lda;
   a_offset = 1 + a_dim1 * 1;
   a -= a_offset;
   bandwidth_u--;
   bandwidth_l--;
   step_type--;
   b--;

   n1=*n;
   kd1=*kd;
	
   ldv1=*lda-1;
   ldv2=1;

   i=1;
   while(i<=n1){
	   if(step_type[i]==4){
		  i++;
		  continue;
	   }
      if(step_type[i]==0){
         bw=bandwidth_u[i];
         for(j=1; j<=bw; j++){
            b[i+j]-=b[i]*a_ref(BAND_FACTOR*kd1+1-j,i+j);
         }
         i++;
      }else{
         bw=bandwidth_l[i];
         for(j=1; j<bw; j++){

            givens=a_ref(BAND_FACTOR*kd1+1+j,i);
            if(givens==1){
               cos_alpha=0;
               sin_alpha=1;
            }else if(abs(givens)<1){
               sin_alpha=2*abs(givens);
               cos_alpha=(givens>=0?1:-1)*sqrt(1-sin_alpha*sin_alpha);
            }else{
               cos_alpha=2/givens;
               sin_alpha=sqrt(1-cos_alpha*cos_alpha);
            }
            {
               int ione=1;
               drot_(&ione,&(b[i+j+1]),&ione,
                           &(b[i+j]),&ione,&cos_alpha,&sin_alpha);
            }

         }
         
         givens=a_ref(BAND_FACTOR*kd1+1+bw,i);
         if(givens==1){
            cos_alpha=0;
            sin_alpha=1;
         }else if(abs(givens)<1){
            sin_alpha=2*givens;
            cos_alpha=sqrt(1-sin_alpha*sin_alpha);
         }else{
            cos_alpha=2/givens;
            sin_alpha=sqrt(1-cos_alpha*cos_alpha);
         }
 

         if(step_type[i]==1){
            tmp=b[i];
            b[i]=cos_alpha*tmp+sin_alpha*b[i+bw];
            b[i+bw]=(-1)*sin_alpha/cos_alpha*tmp+b[i+bw];
            i++;
         }else{
            tmp=b[i];
            b[i]=cos_alpha*tmp+sin_alpha*b[i+bw];
            b[i+bw]=(-1)*sin_alpha*tmp+cos_alpha*b[i+bw];
            for(j=i+bw; j>i+1; j--){
               tmp=b[j];
               b[j]=b[j-1];
               b[j-1]=tmp;
            }
            for(j=1; j<bw-1; j++){

               givens=a_ref(BAND_FACTOR*kd1+1-j,i+j+1);
               if(givens==1){
                  cos_alpha=0;
                  sin_alpha=1;
               }else if(abs(givens)<1){
                  sin_alpha=2*abs(givens);
                  cos_alpha=(givens>=0?1:-1)*sqrt(1-sin_alpha*sin_alpha);
               }else{
                  cos_alpha=2/givens;
                  sin_alpha=sqrt(1-cos_alpha*cos_alpha);
               }
               {
                  int ione=1;
                  drot_(&ione,&(b[i+j+2]),&ione,
                           &(b[i+j+1]),&ione,&cos_alpha,&sin_alpha);
               }

            }
            if(bw > 1){
               for(j=bw-1; j<=bandwidth_u[i+1]; j++){
                  b[i+j+1]-=b[i+1]*a_ref(BAND_FACTOR*kd1+1-j,i+j+1);
               }
            }else{
               for(j=bw; j<=bandwidth_u[i+1]; j++){
                  b[i+j+1]-=b[i+1]*a_ref(BAND_FACTOR*kd1+1-j,i+j+1);
               }
            }
            i+=2;
         }
      }    


   }

   for(i=1; i<=n1; i++){
      if(step_type[i]==4){
          continue;
      }
      if(step_type[i]==0 || step_type[i]==3){
         b[i]/=a_ref(BAND_FACTOR*kd1+1,i);
      }
   }   

   i=n1;
   while(i>=1){
	   if(step_type[i]==4){
		   i--;
		   continue;
	   }

      if(step_type[i]==0){
         bw=bandwidth_u[i];
         for(j=1; j<=bw; j++){
            b[i]-=b[i+j]*a_ref(BAND_FACTOR*kd1+1-j,i+j);
         }
         i--;
      }else{
         if(step_type[i]==3){
            bw=bandwidth_l[i-1];

            givens=a_ref(BAND_FACTOR*kd1+1+bw,i-1);
            if(givens==1){
               cos_alpha=0;
               sin_alpha=1;
            }else if(abs(givens)<1){
               sin_alpha=2*givens;
               cos_alpha=sqrt(1-sin_alpha*sin_alpha);
            }else{
               cos_alpha=2/givens;
               sin_alpha=sqrt(1-cos_alpha*cos_alpha);
            }
     
            if(bw > 1){
               for(j=bw-1; j<=bandwidth_u[i]; j++){
                  b[i]-=b[i+j]*a_ref(BAND_FACTOR*kd1+1-j,i+j)*cos_alpha;
               }
            }else{
               for(j=bw; j<=bandwidth_u[i]; j++){
                  b[i]-=b[i+j]*a_ref(BAND_FACTOR*kd1+1-j,i+j)*cos_alpha;
               }
            }

            for(j=bw-2 ; j>=1; j--){

               givens=a_ref(BAND_FACTOR*kd1+1-j,i+j);
               if(givens==1){
                  cos_alpha=0;
                  sin_alpha=-1;
               }else if(abs(givens)<1){
                  sin_alpha=-2*abs(givens);
                  cos_alpha=(givens>=0?1:-1)*sqrt(1-sin_alpha*sin_alpha);
               }else{
                  cos_alpha=2/givens;
                  sin_alpha=(-1)*sqrt(1-cos_alpha*cos_alpha);
               }
               {
                  int ione=1;
                  drot_(&ione,&(b[i+j+1]),&ione,
                              &(b[i+j]),&ione,&cos_alpha,&sin_alpha);
               }

            }

            for(j=i+1; j<=i+bw-1; j++){
               tmp=b[j];
               b[j]=b[j-1];
               b[j-1]=tmp;
            }

            i--;
         }

         b[i]/=a_ref(BAND_FACTOR*kd1+1,i);
         bw=bandwidth_u[i];
         for(j=1; j<=bw; j++){
            b[i]-=(a_ref(BAND_FACTOR*kd1+1-j,i+j)/a_ref(BAND_FACTOR*kd1+1,i))*b[i+j];
         }


         bw=bandwidth_l[i];
         for(j=bw-1; j>=1; j--){


            givens=a_ref(BAND_FACTOR*kd1+1+j,i);
            if(givens==1){
               cos_alpha=0;
               sin_alpha=-1;
            }else if(abs(givens)<1){
               sin_alpha=(-2)*abs(givens);
               cos_alpha=(givens>=0?1:-1)*sqrt(1-sin_alpha*sin_alpha);
            }else{
               cos_alpha=2/givens;
               sin_alpha=(-1)*sqrt(1-cos_alpha*cos_alpha);
            }
            {
               int ione=1;
               drot_(&ione,&(b[i+j+1]),&ione,
                           &(b[i+j]),&ione,&cos_alpha,&sin_alpha);
            }
         } 
         i--;

     }
   }

   return 0;
}

