function A = banded(n,m,nev);
% A = banded(n,m,neg_ev)
% 
% creates a symmetric banded n-by-n matrix with half band m
% and with the given number of negative eigenvalues

A = diag( rand(n,1) );

for d = 1:min(m,n-1)
	A = A + diag( rand(n-d,1), d );
end

A = A+A';

e = eig(A);

if (nev <  1); nev = 1  ; end
if (nev >= n); nev = n-1; end

shift = e(nev) + ( (e(nev+1) - e(nev)) / 2 );

A = A - shift*eye(n);

end